=begin
#rokka.io

#digital image processing done right. [Documentation](https://rokka.io/documentation). [Changelog](https://api.rokka.io/changelog.md).

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.3.1

=end

require 'date'

module RokkaClientCodegen

  class SourceImage
    attr_accessor :long_hash

    attr_accessor :short_hash

    attr_accessor :binary_hash

    attr_accessor :created

    attr_accessor :name

    attr_accessor :mimetype

    attr_accessor :format

    attr_accessor :size

    attr_accessor :width

    attr_accessor :height

    attr_accessor :organization

    attr_accessor :link

    attr_accessor :dynamic_metadata

    attr_accessor :static_metadata

    attr_accessor :user_metadata

    # Null as default (means false)
    attr_accessor :deleted

    attr_accessor :deleted_date


    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'long_hash' => :'hash',
        :'short_hash' => :'short_hash',
        :'binary_hash' => :'binary_hash',
        :'created' => :'created',
        :'name' => :'name',
        :'mimetype' => :'mimetype',
        :'format' => :'format',
        :'size' => :'size',
        :'width' => :'width',
        :'height' => :'height',
        :'organization' => :'organization',
        :'link' => :'link',
        :'dynamic_metadata' => :'dynamic_metadata',
        :'static_metadata' => :'static_metadata',
        :'user_metadata' => :'user_metadata',
        :'deleted' => :'deleted',
        :'deleted_date' => :'deleted_date'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'long_hash' => :'String',
        :'short_hash' => :'String',
        :'binary_hash' => :'String',
        :'created' => :'DateTime',
        :'name' => :'String',
        :'mimetype' => :'String',
        :'format' => :'String',
        :'size' => :'Integer',
        :'width' => :'Integer',
        :'height' => :'Integer',
        :'organization' => :'String',
        :'link' => :'String',
        :'dynamic_metadata' => :'Object',
        :'static_metadata' => :'Object',
        :'user_metadata' => :'Object',
        :'deleted' => :'BOOLEAN',
        :'deleted_date' => :'DateTime'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'hash')
        self.long_hash = attributes[:'hash']
      end

      if attributes.has_key?(:'short_hash')
        self.short_hash = attributes[:'short_hash']
      end

      if attributes.has_key?(:'binary_hash')
        self.binary_hash = attributes[:'binary_hash']
      end

      if attributes.has_key?(:'created')
        self.created = attributes[:'created']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'mimetype')
        self.mimetype = attributes[:'mimetype']
      end

      if attributes.has_key?(:'format')
        self.format = attributes[:'format']
      end

      if attributes.has_key?(:'size')
        self.size = attributes[:'size']
      end

      if attributes.has_key?(:'width')
        self.width = attributes[:'width']
      end

      if attributes.has_key?(:'height')
        self.height = attributes[:'height']
      end

      if attributes.has_key?(:'organization')
        self.organization = attributes[:'organization']
      end

      if attributes.has_key?(:'link')
        self.link = attributes[:'link']
      end

      if attributes.has_key?(:'dynamic_metadata')
        self.dynamic_metadata = attributes[:'dynamic_metadata']
      end

      if attributes.has_key?(:'static_metadata')
        self.static_metadata = attributes[:'static_metadata']
      end

      if attributes.has_key?(:'user_metadata')
        self.user_metadata = attributes[:'user_metadata']
      end

      if attributes.has_key?(:'deleted')
        self.deleted = attributes[:'deleted']
      end

      if attributes.has_key?(:'deleted_date')
        self.deleted_date = attributes[:'deleted_date']
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          hash == o.hash &&
          short_hash == o.short_hash &&
          binary_hash == o.binary_hash &&
          created == o.created &&
          name == o.name &&
          mimetype == o.mimetype &&
          format == o.format &&
          size == o.size &&
          width == o.width &&
          height == o.height &&
          organization == o.organization &&
          link == o.link &&
          dynamic_metadata == o.dynamic_metadata &&
          static_metadata == o.static_metadata &&
          user_metadata == o.user_metadata &&
          deleted == o.deleted &&
          deleted_date == o.deleted_date
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [long_hash, short_hash, binary_hash, created, name, mimetype, format, size, width, height, organization, link, dynamic_metadata, static_metadata, user_metadata, deleted, deleted_date].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = RokkaClientCodegen.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
